#!/usr/bin/python
#
# Given a database (output of carnarvon)
# creates a new table (functionsTerr) with developer territoriality
# information
#
# (c) 2008-12 Gregorio Robles
# Released under GNU GPLv3 or later

import MySQLdb

# Database connection
db = MySQLdb.connect("localhost", "operator", "operator", "carnarvon_dizquierdo_evolution")
c= db.cursor()

print "USE carnarvon_dizquierdo_evolution;"
print ""
print "CREATE TABLE IF NOT EXISTS functionsTerr ("
print "  function_id      int(8) NOT NULL,"
print "  timestamp_id     int(8) NOT NULL,"
print "  commiter_id      int(8) NOT NULL,"
print "  numberOfLines    int(8) NOT NULL,"
print "  contribution     int(8) NOT NULL,"
print "  max_commiter     int(8) NOT NULL,"    # 1 if yes, 0 else
print "  PRIMARY KEY(function_id,timestamp_id,commiter_id)"
print ");"
print ""


# Let's get a dict with the timestamp_is pointing to the timestamp

datesDict = {}

query = "SELECT timestamp_id, timestamp FROM dates"
print "#", query

c.execute(query)
for (timestamp_id, timestamp) in c.fetchall():
    year  = timestamp.year
    month = timestamp.month
    if month < 10:
        month = "0" + str(month)
    day   = timestamp.day
    if day < 10:
        day = "0" + str(day)
    timestamp = str(year) + '_' + str(month) + '_' + str(day)
    datesDict[timestamp_id] = timestamp

# Let's get all functions

print ""
query = "SELECT function_id, timestamp_id, file_id, start_line, end_line FROM functionsAll ORDER BY function_id"
print "#", query

c.execute(query)
for (function_id, timestamp_id, file_id, start_line, end_line) in c.fetchall():
    query = "SELECT commiter_id, COUNT(*) AS count FROM annotates_" + datesDict[timestamp_id] + " WHERE file_id=" + str(file_id) +" AND line_id>" + str(start_line-1) + " AND line_id<" + str(end_line+1) + " GROUP BY commiter_id ORDER BY count DESC"
    print "#", query
    c.execute(query)
    functionAuthorsList = c.fetchall()
    print "#",
    print functionAuthorsList

    if len(functionAuthorsList) == 0:
        print "#", "ERROR found in this query!"

    for integer in range(len(functionAuthorsList)):
        commiter_id = functionAuthorsList[integer][0]
        numberOfLines = functionAuthorsList[integer][1]
        contribution = int(round(functionAuthorsList[integer][1] * 100.0/(end_line - start_line + 1)))
        if integer == 0:
            max_commiter = 1
        else:
            max_commiter = 0
        query = "INSERT INTO functionsTerr (function_id, timestamp_id, commiter_id, numberOfLines, contribution, max_commiter) "
        query += " VALUES ('" + str(function_id) + "','"
        query += str(timestamp_id) + "','"
        query += str(str(commiter_id)) + "','"
        query += str(str(numberOfLines)) + "','"        
        query += str(str(contribution)) + "','"
        query += str(str(max_commiter)) + "');"

        print query

