#!/usr/bin/python
#
# Obtains statistical information for
# Hypothesis 4.
#
# Usage:
# ./hipo4process.py minimum_age_functions_in_months last_commit_committer_months (orph|non)
#
# (c) 2008-12 Gregorio Robles
# Released under GNU GPLv3 (or later)

# Evolution:
#from hipodataEvolution import *
# Apache:
from hipodataApache import *

import stats
import sys

totalFunctions = 2177 # Apache
# totalFunctions = 12645 # Evolution

monthsFunction = int(sys.argv[1])
monthsGiven    = int(sys.argv[2])
typeOfFunct    = sys.argv[3]    

output_old = open("apache-output-old.dat", "w")
output_orph = open("apache-output-orph.dat", "w")

dates  = [
    '1996-01',
    '1996-02',
    '1996-03',
    '1996-04',
    '1996-05',
    '1996-06',
    '1996-07',
    '1996-08',
    '1996-09',
    '1996-10',
    '1996-11',
    '1996-12',
    '1997-01',
    '1997-02',
    '1997-03',
    '1997-04',
    '1997-05',
    '1997-06',
    '1997-07',
    '1997-08',
    '1997-09',
    '1997-10',
    '1997-11',
    '1997-12',
    '1998-01',
    '1998-02',
    '1998-03',
    '1998-04',
    '1998-05',
    '1998-06',
    '1998-07',
    '1998-08',
    '1998-09',
    '1998-10',
    '1998-11',
    '1998-12',
    '1999-01',
    '1999-02',
    '1999-03',
    '1999-04',
    '1999-05',
    '1999-06',
    '1999-07',
    '1999-08',
    '1999-09',
    '1999-10',
    '1999-11',
    '1999-12',
    '2000-01',
    '2000-02',
    '2000-03',
    '2000-04',
    '2000-05',
    '2000-06',
    '2000-07',
    '2000-08',
    '2000-09',
    '2000-10',
    '2000-11',
    '2000-12',
    '2001-01',
    '2001-02',
    '2001-03',
    '2001-04',
    '2001-05',
    '2001-06',
    '2001-07',
    '2001-08',
    '2001-09',
    '2001-10',
    '2001-11',
    '2001-12',
    '2002-01',
    '2002-02',
    '2002-03',
    '2002-04',
    '2002-05',
    '2002-06',
    '2002-07',
    '2002-08',
    '2002-09',
    '2002-10',
    '2002-11',
    '2002-12',
    '2003-01',
    '2003-02',
    '2003-03',
    '2003-04',
    '2003-05',
    '2003-06',
    '2003-07',
    '2003-08',
    '2003-09',
    '2003-10',
    '2003-11',
    '2003-12',
    '2004-01',
    '2004-02',
    '2004-03',
    '2004-04',
    '2004-05',
    '2004-06',
    '2004-07',
    '2004-08',
    '2004-09',
    '2004-10',
    '2004-11',
    '2004-12',
    '2005-01',
    '2005-02',
    '2005-03',
    '2005-04',
    '2005-05',
    '2005-06',
    '2005-07',
    '2005-08',
    '2005-09',
    '2005-10',
    '2005-11',
    '2005-12',
    '2006-01',
    '2006-02',
    '2006-03',
    '2006-04',
    '2006-05',
    '2006-06',
    '2006-07',
    '2006-08',
    '2006-09',
    '2006-10',
    '2006-11',
    '2006-12',
    '2007-01',
    '2007-02',
    '2007-03',
    '2007-04',
    '2007-05',
    '2007-06',
    '2007-07',
    '2007-08',
    '2007-09',
    '2007-10',
    '2007-11',
    '2007-12',
    '2008-01',
    '2008-02'
    ]


list_orph = []
list_old = []

# (1) Tengo que tomar las funciones y ver sus modificaciones
#     y quien las ha hecho
# (2) Ver cuando fue la fecha de "orfandad"

for function in modificationsDict:
    owner = ownerOfFunctionDict[function]
    try:
        # months the function if orphan
        orphaned = len(dates) - dates.index(lastCommitDict[ownerOfFunctionDict[function]][:7]) -1
    except KeyError:
        pass
#    print function, owner, orphaned, modificationsDict[function]

    number_orphaned_changes = 0
    number_changes = 0
    number_changes_not_owner = 0
    for mod in modificationsDict[function]:
        month    = mod[0]
        commiter = mod[1]
        if month < orphaned:
            number_orphaned_changes += 1
        else:
            if commiter != owner:
                number_changes_not_owner +=1
#        if month <= monthsFunction:
        if month <= 36:
            number_changes +=1
    if functionAgeDict[function] > monthsFunction:

        if orphaned > monthsGiven and functionAgeDict[function] > orphaned:
            list_orph.append(number_changes)
            output_orph.write(str(function) + "\t" +  str(number_changes) + "\t" +  str(number_changes_not_owner + number_orphaned_changes) + "\t" +  str(number_orphaned_changes) + "\t" +  str(functionAgeDict[function]) + "\t" +  str(orphaned) + "\n")
        elif orphaned < monthsGiven:
            list_old.append(number_changes)
            output_old.write(str(function) + "\t" +  str(number_changes) + "\t" +  str(number_changes_not_owner + number_orphaned_changes) + "\t" +  str(number_orphaned_changes) + "\t" +  str(functionAgeDict[function]) + "\t" +  str(orphaned) + "\n")

    if function > totalFunctions:
        break

if typeOfFunct == "orph":
    list = list_orph
    sum = 0
    for item in list:
        sum+=item
    print "$>$", monthsFunction, '&',
    print " ", '&',
    print "$>$", monthsGiven, 'months &',
    print len(list), '&', # "NumberFunctions:"
    print sum, '&', # "NumberChanges:"
    print round(stats.mean(list),2), '&', # "Mean:", 
    print int(round(stats.median(list),1)), '&', # "Median:"
    print str(stats.mode(list)[1][0]) + " (" + str(stats.mode(list)[0]) + ")", '&', # "Mode:", 
    print round(stats.stdev(list),2), '\\\\' # "StDev:"
#    print stats.itemfreq(list) # "Itemfreq:", 

else:
    list = list_old
    sum = 0
    for item in list:
        sum+=item
    print "N $>$", monthsFunction, '&',
    print " ", '&',
    print "$<$", monthsGiven, 'months &',
    print len(list), '&', # "NumberFunctions:"
    print sum, '&', # "NumberChanges:"
    print round(stats.mean(list),2), '&', # "Mean:", 
    print int(round(stats.median(list),1)), '&', # "Median:"
    print str(stats.mode(list)[1][0]) + " (" + str(stats.mode(list)[0]) + ")", '&', # "Mode:", 
    print round(stats.stdev(list),2), '\\\\' # "StDev:"
#print stats.itemfreq(list) # "Itemfreq:", 


# modificationsDict
# functionsByCommiterDict
# lastCommitDict
# ownerOfFunctionDict
# functionAgeDict
